﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace adx_ol_cs_ProcessItemEvents
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("42ED3E96-78E4-43B3-AA44-9702BC6A7D36"), ProgId("adx_ol_cs_ProcessItemEvents.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXOutlookAppEvents adxOutlookEvents;
        private OutlookItemEventsClass itemEvents = null;
        private bool canConnect = true;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.ItemSend += new AddinExpress.MSO.ADXOlItemSend_EventHandler(this.adxOutlookEvents_ItemSend);
            this.adxOutlookEvents.InspectorActivate += new AddinExpress.MSO.ADXOlInspector_EventHandler(this.adxOutlookEvents_InspectorActivate);
            this.adxOutlookEvents.InspectorClose += new AddinExpress.MSO.ADXOlInspector_EventHandler(this.adxOutlookEvents_InspectorClose);
            this.adxOutlookEvents.ExplorerClose += new AddinExpress.MSO.ADXOlExplorer_EventHandler(this.adxOutlookEvents_ExplorerClose);
            // 
            // AddinModule
            // 
            this.AddinName = "adx_ol_cs_ProcessItemEvents";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);
            this.AddinBeginShutdown += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinBeginShutdown);

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            if (this.HostMajorVersion == 9)
            {
                if (this.HostVersion.IndexOf("9.") == 0)
                    MessageBox.Show("We don't recommend using the 'ADXOutlookItemEvents' class in Microsoft Outlook 2000.\n\rOutlook 2000 can hang in the background.",
                        AddinName, MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
            else
            {
                itemEvents = new OutlookItemEventsClass(this);
            }
        }

        private void adxOutlookEvents_InspectorActivate(object sender, object inspector, string folderName)
        {
            if (canConnect)
            {
                Outlook._Inspector currInspector = inspector as Outlook._Inspector;
                itemEvents.ConnectTo(currInspector.CurrentItem, true);
            }
        }

        private void adxOutlookEvents_ItemSend(object sender, ADXOlItemSendEventArgs e)
        {
            if (itemEvents != null)
                itemEvents.RemoveConnection();
        }

        private void adxOutlookEvents_ExplorerClose(object sender, object explorer)
        {
            int count = 0;
            Outlook._Explorers explorers = null;

            try
            {
                explorers = OutlookApp.Explorers;
                count = explorers.Count;
            }
            catch
            {
            }
            finally
            {
                if (explorers != null) Marshal.ReleaseComObject(explorers);
            }

            if (count == 0)
                canConnect = false;
        }

        private void adxOutlookEvents_InspectorClose(object sender, object inspector, string folderName)
        {
            if (itemEvents != null)
                itemEvents.RemoveConnection();
        }

        private void AddinModule_AddinBeginShutdown(object sender, EventArgs e)
        {
            if (itemEvents != null)
                itemEvents.Dispose();
        }
    }
}

